/* ----------------------------------------------------------------------------------------------- */
/*  Copyright (c) 2014 - 2019 by Axel Kenzo, axelkenzo@mail.ru                                     */
/*                                                                                                 */
/*  Файл libakrypt-mini.h                                                                          */
/*  - содержит перечень экспортируемых интерфейсов библиотеки mini-libakrypt                       */
/* ----------------------------------------------------------------------------------------------- */
#ifndef __LIBAKRYPT_H__
#define __LIBAKRYPT_H__

/* ----------------------------------------------------------------------------------------------- */
#ifdef __cplusplus
extern "C" {
#endif

/* ----------------------------------------------------------------------------------------------- */
#include <sys/types.h>
#ifndef LIBAKRYPT_LITTLE_ENDIAN
#include <byteswap.h>
#endif

/* ----------------------------------------------------------------------------------------------- */
typedef int ak_int32;
typedef unsigned int ak_uint32;
typedef long long ak_int64;
typedef unsigned long long ak_uint64;
typedef char ak_int8;
typedef unsigned char ak_uint8;

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Определение булева типа, принимающего значения либо истина, либо ложь. */
typedef enum { ak_false, ak_true } ak_bool;

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Указатель на произвольный объект библиотеки. */
typedef void *ak_pointer;

/* ----------------------------------------------------------------------------------------------- */
#define ak_max(x, y) ((x) > (y) ? (x) : (y))
#define ak_min(x, y) ((x) < (y) ? (x) : (y))

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Результат, говорящий об отсутствии ошибки. */
#define ak_error_ok (0)
/*! \brief Ошибка выделения оперативной памяти. */
#define ak_error_out_of_memory (-1)
/*! \brief Ошибка, возникающая при доступе или передаче в качестве аргумента функции null указателя. */
#define ak_error_null_pointer (-2)
/*! \brief Ошибка, возникащая при передаче аргументов функции или выделении памяти нулевой длины. */
#define ak_error_zero_length (-3)
/*! \brief Ошибка, возникающая при обработке данных ошибочной длины. */
#define ak_error_wrong_length (-4)
/*! \brief Использование неопределенного значения. */
#define ak_error_undefined_value (-5)
/*! \brief Использование неопределенного указателя на функцию (вызов null указателя). */
#define ak_error_undefined_function (-6)
/*! \brief Ошибка переполнения контролируемой переменной */
#define ak_error_overflow (-7)
/*! \brief Попытка доступа к неопределенной опции библиотеки. */
#define ak_error_wrong_option (-8)

/*! \brief Ошибка создания файла. */
#define ak_error_create_file (-10)
/*! \brief Ошибка доступа к файлу (устройству). */
#define ak_error_access_file (-11)
/*! \brief Ошибка открытия файла (устройства). */
#define ak_error_open_file (-12)
/*! \brief Ошибка закрытия файла (устройства). */
#define ak_error_close_file (-13)
/*! \brief Ошибка чтения из файла (устройства). */
#define ak_error_read_data (-14)
/*! \brief Ошибка записи в файл (устройство). */
#define ak_error_write_data (-15)
/*! \brief Ошибка записи в файл - файл существует */
#define ak_error_file_exists (-16)

/*! \brief Ошибка при сравнении двух массивов данных. */
#define ak_error_not_equal_data (-20)
/*! \brief Ошибка выполнения библиотеки на неверной архитектуре. */
#define ak_error_wrong_endian (-21)
/*! \brief Ошибка чтения из терминала. */
#define ak_error_terminal (-22)

/*! \brief Неверное значение дескриптора объекта. */
#define ak_error_wrong_handle (-30)
/*! \brief Попытка создания и/или использования ранее созданного менеджера контектстов */
#define ak_error_context_manager_usage (-31)
/*! \brief Ошибка, возникающая в случае неправильного значения размера структуры хранения контекстов. */
#define ak_error_context_manager_size (-32)
/*! \brief Ошибка, возникающая при превышении числа возможных элементов структуры хранения контекстов. */
#define ak_error_context_manager_max_size (-33)

/*! \brief Неверный тип криптографического механизма. */
#define ak_error_oid_engine (-40)
/*! \brief Неверный режим использования криптографического механизма. */
#define ak_error_oid_mode (-41)
/*! \brief Ошибочное или не определенное имя криптографического механизма. */
#define ak_error_oid_name (-42)
/*! \brief Ошибочный или неопределенный идентификатор криптографического механизма. */
#define ak_error_oid_id (-43)
/*! \brief Ошибочный индекс идентификатора криптографического механизма. */
#define ak_error_oid_index (-44)
/*! \brief Ошибка с обращением к oid. */
#define ak_error_wrong_oid (-45)

/*! \brief Ошибка, возникающая при использовании ключа, значение которого не определено. */
#define ak_error_key_value (-51)
/*! \brief Ошибка, возникающая при использовании ключа для бесключевых функций. */
#define ak_error_key_usage (-52)
/*! \brief Ошибка, возникающая при неверном заполнении полей структуры bckey. */
#define ak_error_wrong_block_cipher (-53)
/*! \brief Ошибка, возникающая при зашифровании/расшифровании данных, длина которых не кратна длине блока. */
#define ak_error_wrong_block_cipher_length (-54)
/*! \brief Ошибка, возникающая при неверном значении кода целостности ключа. */
#define ak_error_wrong_key_icode (-55)
/*! \brief Ошибка, возникающая при неверном значении длины ключа. */
#define ak_error_wrong_key_length (-57)
/*! \brief Ошибка, возникающая при недостаточном ресурсе ключа. */
#define ak_error_low_key_resource (-58)
/*! \brief Ошибка, возникающая при использовании синхропосылки (инициализационного вектора) неверной длины. */
#define ak_error_wrong_iv_length (-59)
/*! \brief Ошибка, возникающая при неправильном использовании функций зашифрования/расшифрования данных. */
#define ak_error_wrong_block_cipher_function (-60)

/*! \brief Ошибка, возникающая когда параметры кривой не соотвествуют алгоритму, в котором они используются. */
#define ak_error_curve_not_supported (-70)
/*! \brief Ошибка, возникающая если точка не принадлежит заданной кривой. */
#define ak_error_curve_point (-71)
/*! \brief Ошибка, возникающая когда порядок точки неверен. */
#define ak_error_curve_point_order (-72)
/*! \brief Ошибка, возникающая если дискриминант кривой равен нулю (уравнение не задает кривую). */
#define ak_error_curve_discriminant (-73)
/*! \brief Ошибка, возникающая когда неверно определены вспомогательные параметры эллиптической кривой. */
#define ak_error_curve_order_parameters (-74)
/*! \brief Ошибка, возникающая когда простой модуль кривой задан неверно. */
#define ak_error_curve_prime_modulo (-75)

/*! \brief Ошибка, возникающая при кодировании ASN1 структуры (перевод в DER-кодировку). */
#define ak_error_wrong_asn1_encode (-90)
/*! \brief Ошибка, возникающая при декодировании ASN1 структуры (перевод из DER-кодировки в ASN1 структуру). */
#define ak_error_wrong_asn1_decode (-91)

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Функция очистки контекста хеширования. */
typedef int(ak_function_mac_clean)(ak_pointer);
/*! \brief Итерационная функция хеширования. */
typedef int(ak_function_mac_update)(ak_pointer, const ak_pointer, const size_t);
/*! \brief Функция завершения вычислений и получения конечного результата. */
typedef int(ak_function_mac_finalize)(ak_pointer, const ak_pointer, const size_t, ak_pointer);

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Структура для хранения внутренних данных контекста функции хеширования Стрибог          */
struct streebog
{
  /*! \brief вектор h - временный */
  ak_uint64 H[8];
  /*! \brief вектор n - временный */
  ak_uint64 N[8];
  /*! \brief вектор  \f$ \Sigma \f$ - контрольная сумма */
  ak_uint64 SIGMA[8];
};

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Класс, реализующий контекст алгоритима хеширования. */
/*! Класс предоставляет интерфейс для реализации различных бесключевых алгоритмов хеширования
    информации, построенных с использованием итеративных сжимающих отображений. В настоящее время
    с использованием класса \ref hash реализованы следующие отечественные алгоритмы хеширования
     - Стрибог256,
     - Стрибог512,
     - ГОСТ Р 34.11-94 (в настоящее время стандарт выведен из обращения).

    Подробное описание методов использования
    объектов класса \ref hash содержится в разделе \ref guide_hash.                                */
/* ----------------------------------------------------------------------------------------------- */
typedef struct hash
{
  /*! \brief размер обрабатываемого блока входных данных */
  size_t bsize;
  /*! \brief размер выходного блока (хеш-кода) */
  size_t hsize;
  /*! \brief указатель на внутренние данные контекста */
  struct streebog data;
  /*! \brief функция очистки контекста */
  ak_function_mac_clean *clean;
  /*! \brief функция обновления состояния контекста */
  ak_function_mac_update *update;
  /*! \brief функция завершения вычислений и получения конечного результата */
  ak_function_mac_finalize *finalize;
} * ak_hash;

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Инициализация контекста функции бесключевого хеширования ГОСТ Р 34.11-2012 (Стрибог256). */
int ak_hash_context_create_streebog256(ak_hash);
/*! \brief Инициализация контекста функции бесключевого хеширования ГОСТ Р 34.11-2012 (Стрибог512). */
int ak_hash_context_create_streebog512(ak_hash);
/*! \brief Хеширование заданной области памяти. */
int ak_hash_context_ptr(ak_hash, const ak_pointer, const size_t, ak_pointer);
/*! \brief Уничтожение контекста функции хеширования. */
int ak_hash_context_destroy(ak_hash);

/* ----------------------------------------------------------------------------------------------- */
/** \addtogroup testing
 *  @{
 */
/*! \brief Проверка корректной работы функции хеширования Стрибог-256 */
ak_bool ak_hash_test_streebog256(void);
/** @}*/

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Секретный ключ алгоритма выработки имитовставки HMAC. */
/*!  Алгоритм выработки имитовставки HMAC основан на двукратном применении бесключевой функции
     хеширования. Алгоритм описывается рекомендациями IETF RFC 2104 (см. также RFC 7836) и
     стандартизован отечественными рекомендациями по стандартизации Р 50.1.113-2016.
     Алгоритм предназначен, в основном, для выработки имитовставки и преобразования ключевой
     информации.

     В нашей реализации алгоритм может быть использован совместно с любой функцией хеширования,
     реализованной в библиотеке. Отметим, что согласно Р 50.1.113-2016 алгоритм рекомендуется
     использовать только совместно с функцией хеширования Стрибог
     (с длиной хеш кода как 256 бит, так и 512 бит).

     \b Внимание! Использование ключей, чья длина превышает размер блока бесключевой функции
     хеширования, реализовано в соответствии с RFC 2104.                                           */
/* ----------------------------------------------------------------------------------------------- */
typedef struct hmac
{
  /*! \brief Ключ алгоритма */
  ak_uint8 key[64];
  /*! \brief контекст функции хеширования */
  struct hash ctx;
} * ak_hmac;

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Создание контекста ключевой функции хеширования HMAC на основе функции Стреебог512. */
int ak_hmac_context_create_streebog512(ak_hmac);
/*! \brief Уничтожение контекста функции хеширования. */
int ak_hmac_context_destroy(ak_hmac);

int ak_hmac_context_create_streebog256(ak_hmac hctx);

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Присвоение секретному ключу константного значения. */
int ak_hmac_context_set_key(ak_hmac, const ak_pointer, const size_t);
/*! \brief Вычисление имитовставки для заданной области памяти. */
int ak_hmac_context_ptr(ak_hmac, const ak_pointer, const size_t, ak_pointer);
/*! \brief Развертка ключевого вектора из пароля (согласно Р 50.1.111-2016, раздел 4) */
int ak_hmac_context_pbkdf2_streebog512(const ak_pointer, const size_t, const ak_pointer, const size_t, const size_t,
                                       const size_t, ak_pointer);

/** \addtogroup testing
 *  @{
 */
/*! \brief Тестирование алгоритмов выработки имитовставки HMAC с отечественными
    функциями хеширования семейства Стрибог (ГОСТ Р 34.11-2012), а также
    тестирование алгоритма PBKDF2, регламентируемого Р 50.1.113-2016. */
int ak_hmac_test_pbkdf2(void);
/** @}*/

/* ----------------------------------------------------------------------------------------------- */
#define ak_mpzn256_size (4)
#define ak_mpzn512_size (8)
#define ak_mpznmax_size (18)

#define ak_mpzn256_zero                                                                                                \
  {                                                                                                                    \
    0, 0, 0, 0                                                                                                         \
  }
#define ak_mpzn256_one                                                                                                 \
  {                                                                                                                    \
    1, 0, 0, 0                                                                                                         \
  }
#define ak_mpzn512_zero                                                                                                \
  {                                                                                                                    \
    0, 0, 0, 0, 0, 0, 0, 0                                                                                             \
  }
#define ak_mpzn512_one                                                                                                 \
  {                                                                                                                    \
    1, 0, 0, 0, 0, 0, 0, 0                                                                                             \
  }
#define ak_mpznmax_zero                                                                                                \
  {                                                                                                                    \
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0                                                               \
  }
#define ak_mpznmax_one                                                                                                 \
  {                                                                                                                    \
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0                                                               \
  }

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Элемент кольца вычетов по модулю \f$2^{256}\f$. */
typedef ak_uint64 ak_mpzn256[ak_mpzn256_size];
/*! \brief Элемент кольца вычетов по модулю \f$2^{512}\f$. */
typedef ak_uint64 ak_mpzn512[ak_mpzn512_size];
/*! \brief Тип данных для хранения максимально возможного большого числа. */
typedef ak_uint64 ak_mpznmax[ak_mpznmax_size];

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Присвоение вычету другого вычета. */
void ak_mpzn_set(ak_uint64 *, ak_uint64 *, const size_t);
/*! \brief Присвоение вычету беззнакового целого значения. */
void ak_mpzn_set_ui(ak_uint64 *, const size_t, const ak_uint64);
/*! \brief Сложение двух вычетов */
ak_uint64 ak_mpzn_add(ak_uint64 *, ak_uint64 *, ak_uint64 *, const size_t);
/*! \brief Вычитание двух вычетов */
ak_uint64 ak_mpzn_sub(ak_uint64 *, ak_uint64 *, ak_uint64 *, const size_t);
/*! \brief Сравнение двух вычетов */
int ak_mpzn_cmp(ak_uint64 *, ak_uint64 *, const size_t);
/*! \brief Сравнение вычета с беззнаковым целым числом (типа ak_uint64) */
ak_bool ak_mpzn_cmp_ui(ak_uint64 *, const size_t, const ak_uint64);
/*! \brief Умножение вычета на беззнаковое целое */
ak_uint64 ak_mpzn_mul_ui(ak_uint64 *, ak_uint64 *, const size_t, const ak_uint64);
/*! \brief Умножение двух вычетов как целых чисел */
void ak_mpzn_mul(ak_uint64 *, ak_uint64 *, ak_uint64 *, const size_t);
/*! \brief Вычисление остатка от деления одного вычета на другой */
void ak_mpzn_rem(ak_uint64 *, ak_uint64 *, ak_uint64 *, const size_t);

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Сложение двух вычетов в представлении Монтгомери. */
void ak_mpzn_add_montgomery(ak_uint64 *, ak_uint64 *, ak_uint64 *, ak_uint64 *, const size_t);
/*! \brief Удвоение на двойку в представлении Монтгомери. */
void ak_mpzn_lshift_montgomery(ak_uint64 *, ak_uint64 *, ak_uint64 *, const size_t);
/*! \brief Умножение двух вычетов в представлении Монтгомери. */
void ak_mpzn_mul_montgomery(ak_uint64 *, ak_uint64 *, ak_uint64 *, ak_uint64 *, ak_uint64, const size_t);
/*! \brief Модульное возведение в степень в представлении Монтгомери. */
void ak_mpzn_modpow_montgomery(ak_uint64 *, ak_uint64 *, ak_uint64 *, ak_uint64 *, ak_uint64, const size_t);

/* ----------------------------------------------------------------------------------------------- */
struct wcurve;
/*! \brief Контекст эллиптической кривой, заданной в короткой форме Вейерштрасса. */
typedef struct wcurve *ak_wcurve;

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Класс, реализующий точку эллиптической кривой.

    Класс представляет собой точку \f$ P \f$ эллиптической кривой, заданной в короткой форме Вейерштрасса,
    в проективных координатах, т.е. точка представляется в виде вектора \f$ P=(x:y:z) \f$,
    удовлетворяющего сравнению \f$ y^2z \equiv x^3 + axz^2 + bz^3 \pmod{p} \f$.
    В дальнейшем, при проведении вычислений, для координат точки используется
    представление Монтгомери.                                                                      */
/* ----------------------------------------------------------------------------------------------- */
struct wpoint
{
  /*! \brief x-координата точки эллиптической кривой */
  ak_uint64 x[ak_mpzn512_size];
  /*! \brief y-координата точки эллиптической кривой */
  ak_uint64 y[ak_mpzn512_size];
  /*! \brief z-координата точки эллиптической кривой */
  ak_uint64 z[ak_mpzn512_size];
};
/*! \brief Контекст точки эллиптической кривой в короткой форме Вейерштрасса */
typedef struct wpoint *ak_wpoint;

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Инициализация и присвоение контексту значения образующей точки эллиптической кривой. */
int ak_wpoint_set(ak_wpoint, ak_wcurve);
/*! \brief Инициализация и присвоение контексту значения бесконечно удаленной точки эллиптической кривой. */
int ak_wpoint_set_as_unit(ak_wpoint, ak_wcurve);
/*! \brief Инициализация и присвоение контексту значения заданной точки эллиптической кривой. */
int ak_wpoint_set_wpoint(ak_wpoint, ak_wpoint, ak_wcurve);

/*! \brief Проверка принадлежности точки заданной кривой. */
ak_bool ak_wpoint_is_ok(ak_wpoint, ak_wcurve);
/*! \brief Проверка порядка заданной точки. */
ak_bool ak_wpoint_check_order(ak_wpoint, ak_wcurve);

/*! \brief Удвоение точки эллиптической кривой, заданной в короткой форме Вейерштрасса. */
void ak_wpoint_double(ak_wpoint, ak_wcurve);
/*! \brief Прибавление к одной точке эллиптической кривой значения другой точки. */
void ak_wpoint_add(ak_wpoint, ak_wpoint, ak_wcurve);
/*! \brief Приведение проективной точки к аффинному виду. */
void ak_wpoint_reduce(ak_wpoint, ak_wcurve);
/*! \brief Вычисление кратной точки эллиптической кривой. */
void ak_wpoint_pow(ak_wpoint, ak_wpoint, ak_uint64 *, size_t, ak_wcurve);

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Класс, реализующий эллиптическую кривую, заданную в короткой форме Вейерштрасса

    Класс определяет эллиптическую кривую, заданную сравнением
    \f$ y^2 \equiv x^3 + ax + b \pmod{p} \f$, а также образующую точку \f$P=(x_P, y_P)\f$
    на этой кривой с заданным порядком \f$ q \f$.

    Порядок \f$ m \f$ всей группы точек эллиптической кривой может быть определен
    из равенства \f$ m = dq \f$, где величину \f$ d \f$ называют кофактором.

    Параметры \f$ n, n_q, r_2\f$ вводятся для оптимизации вычислений. Определим \f$ r = 2^{256}\f$
    или \f$ r=2^{512}\f$, тогда \f$ n \equiv n_0 \pmod{2^{64}}\f$,
    где \f$ n_0 \equiv -p^{-1} \pmod{r}\f$.

    Величина \f$ r_2 \f$ удовлетворяет сравнению \f$ r_2 \equiv r^2 \pmod{p}\f$.                   */
/* ----------------------------------------------------------------------------------------------- */
struct wcurve
{
  /*! \brief Размер параметров эллиптической кривой, исчисляемый количеством 64-х битных блоков. */
  ak_uint32 size;
  /*! \brief Кофактор эллиптической кривой - делитель порядка группы точек. */
  ak_uint32 cofactor;
  /*! \brief Коэффициент \f$ a \f$ эллиптической кривой (в представлении Монтгомери) */
  ak_uint64 a[ak_mpzn512_size];
  /*! \brief Коэффициент \f$ b \f$ эллиптической кривой (в представлении Монтгомери). */
  ak_uint64 b[ak_mpzn512_size];
  /*! \brief Модуль \f$ p \f$ эллиптической кривой. */
  ak_uint64 p[ak_mpzn512_size];
  /*! \brief Величина \f$ r^2\f$, взятая по модулю \f$ p \f$ и используемая в арифметике Монтгомери. */
  ak_uint64 r2[ak_mpzn512_size];
  /*! \brief Порядок \f$ q \f$ подгруппы, порождаемой образующей точкой \f$ P \f$. */
  ak_uint64 q[ak_mpzn512_size];
  /*! \brief Величина \f$ r^2\f$, взятая по модулю \f$ q \f$ и используемая в арифметике Монтгомери. */
  ak_uint64 r2q[ak_mpzn512_size];
  /*! \brief Точка \f$ P \f$ эллиптической кривой, порождающая подгруппу порядка \f$ q \f$. */
  struct wpoint point;
  /*! \brief Константа \f$ n \f$, используемая в арифметике Монтгомери по модулю \f$ p \f$. */
  ak_uint64 n;
  /*! \brief Константа \f$ n_q \f$, используемая в арифметике Монтгомери по модулю \f$ q\f$. */
  ak_uint64 nq;
  /*! \brief Строка, содержащая символьную запись модуля \f$ p \f$.
      \details Используется для проверки корректного хранения парметров кривой в памяти. */
  const char *pchar;
};

/* ----------------------------------------------------------------------------------------------- */
extern struct wcurve id_tc26_gost_3410_2012_256_paramSetA;
extern struct wcurve id_rfc4357_gost_3410_2001_paramSetA;
extern struct wcurve id_rfc4357_gost_3410_2001_paramSetB;
extern struct wcurve id_rfc4357_gost_3410_2001_paramSetC;

#define id_tc26_gost_3410_2012_256_paramSetB (id_rfc4357_gost_3410_2001_paramSetA)
#define id_tc26_gost_3410_2012_256_paramSetC (id_rfc4357_gost_3410_2001_paramSetB)
#define id_tc26_gost_3410_2012_256_paramSetD (id_rfc4357_gost_3410_2001_paramSetC)

extern struct wcurve id_tc26_gost_3410_2012_512_paramSetA;
extern struct wcurve id_tc26_gost_3410_2012_512_paramSetB;
extern struct wcurve id_tc26_gost_3410_2012_512_paramSetC;

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Вычисление дискриминанта эллиптической кривой, заданной в короткой форме Вейерштрасса. */
void ak_mpzn_set_wcurve_discriminant(ak_uint64 *, ak_wcurve);
/*! \brief Проверка корректности дискриминанта эллиптической кривой, заданной в форме Вейерштрасса. */
int ak_wcurve_discriminant_is_ok(ak_wcurve);
/*! \brief Проверка корректности параметров, необходимых для вычисления по модулю q. */
int ak_wcurve_check_order_parameters(ak_wcurve);
/*! \brief Проверка набора параметров эллиптической кривой, заданной в форме Вейерштрасса. */
int ak_wcurve_is_ok(ak_wcurve);

/** \addtogroup testing
 *  @{
 */
/*! \brief Функция тестирует все определяемые библиотекой параметры эллиптических кривых,
    заданных в короткой форме Вейерштрасса. */
int ak_wcurve_test(void);
/** @}*/

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Открытый ключ алгоритма проверки электронной подписи ГОСТ Р 34.10-2012.

   Ключ может рассматриваться в качестве открытого ключа как для действующего стандарта
   ГОСТ Р 34.10-2012, так и для предыдущей редакции 2001 года. Кроме того, данный контекст
   открытого ключа может быть применим для любого асимметричного криптографического механизма,
   использующего вычисления с эллиптическими кривыми в короткой форме Вейерштрасса.                */
/* ----------------------------------------------------------------------------------------------- */
typedef struct verifykey
{
  /*! \brief контекст функции хеширования */
  struct hash ctx;
  /*! \brief контекст эллиптической кривой */
  ak_wcurve wc;
  /*! \brief точка кривой, являющаяся открытым ключом */
  struct wpoint qpoint;
} * ak_verifykey;

/* ----------------------------------------------------------------------------------------------- */
/*! \brief Инициализация контекста открытого ключа алгоритма ГОСТ Р 34.10-2012. */
int ak_verifykey_context_create_from_ptr(ak_verifykey, ak_pointer, size_t, const ak_wcurve);
/*! \brief Уничтожение контекста открытого ключа. */
int ak_verifykey_context_destroy(ak_verifykey);
/*! \brief Проверка электронной подписи для вычисленного заранее значения хеш-функции. */
ak_bool ak_verifykey_context_verify_hash(ak_verifykey, const ak_pointer, const size_t, ak_pointer);
/*! \brief Проверка электронной подписи для заданной области памяти. */
ak_bool ak_verifykey_context_verify_ptr(ak_verifykey, const ak_pointer, const size_t, ak_pointer);
#ifdef __cplusplus
} /* конец extern "C" */
#endif
#endif

/* ----------------------------------------------------------------------------------------------- */
/*                                                                                libakrypt-mini.h */
/* ----------------------------------------------------------------------------------------------- */
